## suitesparse 4.2.1

=== Makefile ===
# CC = cc
# CF = -O

default: all

include ../../SuiteSparse_config/SuiteSparse_config.mk

I = -I../Include -I../../SuiteSparse_config

CS = ../Lib/libcxsparse.a

all: $(CS) cs_demo1 cs_demo2 cs_demo3 \
	cs_di_demo1 cs_di_demo2 cs_di_demo3 \
	cs_dl_demo1 cs_dl_demo2 cs_dl_demo3 \
	cs_ci_demo1 cs_ci_demo2 cs_ci_demo3 \
	cs_cl_demo1 cs_cl_demo2 cs_cl_demo3  \
	tests cs_idemo

tests: test_convert test test_di test_dl test_ci test_cl

test: cs_demo1 cs_demo2 cs_demo3
	- ./cs_demo1 < ../Matrix/t1
	- ./cs_demo2 < ../Matrix/t1
	- ./cs_demo2 < ../Matrix/fs_183_1
	- ./cs_demo2 < ../Matrix/west0067
	- ./cs_demo2 < ../Matrix/lp_afiro
	- ./cs_demo2 < ../Matrix/ash219
	- ./cs_demo2 < ../Matrix/mbeacxc
	- ./cs_demo2 < ../Matrix/bcsstk01
	- ./cs_demo3 < ../Matrix/bcsstk01
	- ./cs_demo2 < ../Matrix/bcsstk16
	- ./cs_demo3 < ../Matrix/bcsstk16

test_di: cs_di_demo1 cs_di_demo2 cs_di_demo3
	- ./cs_di_demo1 < ../Matrix/t1
	- ./cs_di_demo2 < ../Matrix/t1
	- ./cs_di_demo2 < ../Matrix/fs_183_1
	- ./cs_di_demo2 < ../Matrix/west0067
	- ./cs_di_demo2 < ../Matrix/lp_afiro
	- ./cs_di_demo2 < ../Matrix/ash219
	- ./cs_di_demo2 < ../Matrix/mbeacxc
	- ./cs_di_demo2 < ../Matrix/bcsstk01
	- ./cs_di_demo3 < ../Matrix/bcsstk01
	- ./cs_di_demo2 < ../Matrix/bcsstk16
	- ./cs_di_demo3 < ../Matrix/bcsstk16

test_dl: cs_dl_demo1 cs_dl_demo2 cs_dl_demo3
	- ./cs_dl_demo1 < ../Matrix/t1
	- ./cs_dl_demo2 < ../Matrix/t1
	- ./cs_dl_demo2 < ../Matrix/fs_183_1
	- ./cs_dl_demo2 < ../Matrix/west0067
	- ./cs_dl_demo2 < ../Matrix/lp_afiro
	- ./cs_dl_demo2 < ../Matrix/ash219
	- ./cs_dl_demo2 < ../Matrix/mbeacxc
	- ./cs_dl_demo2 < ../Matrix/bcsstk01
	- ./cs_dl_demo3 < ../Matrix/bcsstk01
	- ./cs_dl_demo2 < ../Matrix/bcsstk16
	- ./cs_dl_demo3 < ../Matrix/bcsstk16

test_ci: cs_ci_demo1 cs_ci_demo2 cs_ci_demo3
	- ./cs_ci_demo1 < ../Matrix/t2
	- ./cs_ci_demo2 < ../Matrix/t2
	- ./cs_ci_demo2 < ../Matrix/t3
	- ./cs_ci_demo2 < ../Matrix/t4
	- ./cs_ci_demo2 < ../Matrix/c_west0067
	- ./cs_ci_demo2 < ../Matrix/c_mbeacxc
	- ./cs_ci_demo2 < ../Matrix/young1c
	- ./cs_ci_demo2 < ../Matrix/qc324
	- ./cs_ci_demo2 < ../Matrix/neumann
	- ./cs_ci_demo2 < ../Matrix/c4
	- ./cs_ci_demo3 < ../Matrix/c4
	- ./cs_ci_demo2 < ../Matrix/mhd1280b
	- ./cs_ci_demo3 < ../Matrix/mhd1280b

test_cl: cs_cl_demo1 cs_cl_demo2 cs_cl_demo3
	- ./cs_cl_demo1 < ../Matrix/t2
	- ./cs_cl_demo2 < ../Matrix/t2
	- ./cs_cl_demo2 < ../Matrix/t3
	- ./cs_cl_demo2 < ../Matrix/t4
	- ./cs_cl_demo2 < ../Matrix/c_west0067
	- ./cs_cl_demo2 < ../Matrix/c_mbeacxc
	- ./cs_cl_demo2 < ../Matrix/young1c
	- ./cs_cl_demo2 < ../Matrix/qc324
	- ./cs_cl_demo2 < ../Matrix/neumann
	- ./cs_cl_demo2 < ../Matrix/c4
	- ./cs_cl_demo3 < ../Matrix/c4
	- ./cs_cl_demo2 < ../Matrix/mhd1280b
	- ./cs_cl_demo3 < ../Matrix/mhd1280b

test_convert: cs_idemo cs_ldemo
	- ./cs_idemo < ../Matrix/t2
	- ./cs_ldemo < ../Matrix/t2

$(CS):
	( cd ../Lib ; $(MAKE) )

cs_demo1: $(CS) cs_demo1.c Makefile $(CS)
	$(CC) $(CF) $(I) -o cs_demo1 cs_demo1.c $(CS) -lm

cs_demo2: $(CS) cs_demo2.c cs_demo.c cs_demo.h Makefile $(CS)
	$(CC) $(CF) $(I) -o cs_demo2 cs_demo2.c cs_demo.c $(CS) -lm

cs_demo3: $(CS) cs_demo3.c cs_demo.c cs_demo.h Makefile $(CS)
	$(CC) $(CF) $(I) -o cs_demo3 cs_demo3.c cs_demo.c $(CS) -lm




cs_di_demo1: $(CS) cs_di_demo1.c Makefile $(CS)
	$(CC) $(CF) $(I) -o cs_di_demo1 cs_di_demo1.c $(CS) -lm

cs_di_demo2: $(CS) cs_di_demo2.c cs_di_demo.c cs_di_demo.h Makefile $(CS)
	$(CC) $(CF) $(I) -o cs_di_demo2 cs_di_demo2.c cs_di_demo.c $(CS) -lm

cs_di_demo3: $(CS) cs_di_demo3.c cs_di_demo.c cs_di_demo.h Makefile $(CS)
	$(CC) $(CF) $(I) -o cs_di_demo3 cs_di_demo3.c cs_di_demo.c $(CS) -lm




cs_ci_demo1: $(CS) cs_ci_demo1.c Makefile $(CS)
	$(CC) $(CF) $(I) -o cs_ci_demo1 cs_ci_demo1.c $(CS) -lm

cs_ci_demo2: $(CS) cs_ci_demo2.c cs_ci_demo.c cs_ci_demo.h Makefile $(CS)
	$(CC) $(CF) $(I) -o cs_ci_demo2 cs_ci_demo2.c cs_ci_demo.c $(CS) -lm

cs_ci_demo3: $(CS) cs_ci_demo3.c cs_ci_demo.c cs_ci_demo.h Makefile $(CS)
	$(CC) $(CF) $(I) -o cs_ci_demo3 cs_ci_demo3.c cs_ci_demo.c $(CS) -lm



cs_dl_demo1: $(CS) cs_dl_demo1.c Makefile $(CS)
	$(CC) $(CF) $(I) -o cs_dl_demo1 cs_dl_demo1.c $(CS) -lm

cs_dl_demo2: $(CS) cs_dl_demo2.c cs_dl_demo.c cs_dl_demo.h Makefile $(CS)
	$(CC) $(CF) $(I) -o cs_dl_demo2 cs_dl_demo2.c cs_dl_demo.c $(CS) -lm

cs_dl_demo3: $(CS) cs_dl_demo3.c cs_dl_demo.c cs_dl_demo.h Makefile $(CS)
	$(CC) $(CF) $(I) -o cs_dl_demo3 cs_dl_demo3.c cs_dl_demo.c $(CS) -lm


cs_cl_demo1: $(CS) cs_cl_demo1.c Makefile $(CS)
	$(CC) $(CF) $(I) -o cs_cl_demo1 cs_cl_demo1.c $(CS) -lm

cs_cl_demo2: $(CS) cs_cl_demo2.c cs_cl_demo.c cs_cl_demo.h Makefile $(CS)
	$(CC) $(CF) $(I) -o cs_cl_demo2 cs_cl_demo2.c cs_cl_demo.c $(CS) -lm

cs_cl_demo3: $(CS) cs_cl_demo3.c cs_cl_demo.c cs_cl_demo.h Makefile $(CS)
	$(CC) $(CF) $(I) -o cs_cl_demo3 cs_cl_demo3.c cs_cl_demo.c $(CS) -lm




cs_idemo: $(CS) cs_idemo.c Makefile $(CS)
	$(CC) $(CF) $(I) -o cs_idemo cs_idemo.c $(CS) -lm

cs_ldemo: $(CS) cs_ldemo.c Makefile $(CS)
	$(CC) $(CF) $(I) -DCS_LONG -o cs_ldemo cs_ldemo.c $(CS) -lm


clean:
	- $(RM) *.o

purge: distclean

distclean: clean
	- $(RM) cs_demo1 cs_demo2 cs_demo3 *.a
	- $(RM) cs_di_demo1 cs_di_demo2 cs_di_demo3
	- $(RM) cs_dl_demo1 cs_dl_demo2 cs_dl_demo3
	- $(RM) cs_ci_demo1 cs_ci_demo2 cs_ci_demo3
	- $(RM) cs_cl_demo1 cs_cl_demo2 cs_cl_demo3
	- $(RM) -r cs_idemo cs_ldemo *.dSYM

=== BTF/Makefile ===
#------------------------------------------------------------------------------
# BTF Makefile
#------------------------------------------------------------------------------

VERSION = 1.2.0

default: library

include ../SuiteSparse_config/SuiteSparse_config.mk

library:
	( cd Lib ; $(MAKE) )

clean:
	( cd Lib ; $(MAKE) clean )
	( cd MATLAB ; $(RM) $(CLEAN) )

distclean:
	( cd Lib ; $(MAKE) distclean )
	( cd MATLAB ; $(RM) $(CLEAN) ; $(RM) *.mex* )

purge: distclean

# install BTF
install:
	$(CP) Lib/libbtf.a $(INSTALL_LIB)/libbtf.$(VERSION).a
	( cd $(INSTALL_LIB) ; ln -sf libbtf.$(VERSION).a libbtf.a )
	$(CP) Include/btf.h $(INSTALL_INCLUDE)
	chmod 644 $(INSTALL_LIB)/libbtf*.a
	chmod 644 $(INSTALL_INCLUDE)/btf.h

# uninstall BTF
uninstall:
	$(RM) $(INSTALL_LIB)/libbtf*.a
	$(RM) $(INSTALL_INCLUDE)/btf.h

=== CAMD/Makefile ===
#------------------------------------------------------------------------------
# CAMD Makefile
#------------------------------------------------------------------------------

VERSION = 2.3.1

default: demos

include ../SuiteSparse_config/SuiteSparse_config.mk

demos: all

# Compile all C code.  Do not compile the FORTRAN versions.
all:
	( cd Lib    ; $(MAKE) )
	( cd Demo   ; $(MAKE) )

# compile just the C-callable libraries (not Demos)
library:
	( cd Lib    ; $(MAKE) )

# remove object files, but keep the compiled programs and library archives
clean:
	( cd Lib    ; $(MAKE) clean )
	( cd Demo   ; $(MAKE) clean )
	( cd MATLAB ; $(RM) $(CLEAN) )
	( cd Doc    ; $(MAKE) clean )

# clean, and then remove compiled programs and library archives
purge:
	( cd Lib    ; $(MAKE) purge )
	( cd Demo   ; $(MAKE) purge )
	( cd MATLAB ; $(RM) $(CLEAN) ; $(RM) *.mex* )
	( cd Doc    ; $(MAKE) purge )

distclean: purge

# create PDF documents for the original distribution
docs:
	( cd Doc    ; $(MAKE) )

# get ready for distribution
dist: purge
	( cd Demo   ; $(MAKE) dist )
	( cd Doc    ; $(MAKE) )

ccode: library

lib: library

# install CAMD
install:
	$(CP) Lib/libcamd.a $(INSTALL_LIB)/libcamd.$(VERSION).a
	( cd $(INSTALL_LIB) ; ln -sf libcamd.$(VERSION).a libcamd.a )
	$(CP) Include/camd.h $(INSTALL_INCLUDE)
	chmod 644 $(INSTALL_LIB)/libcamd*.a
	chmod 644 $(INSTALL_INCLUDE)/camd.h

# uninstall CAMD
uninstall:
	$(RM) $(INSTALL_LIB)/libcamd*.a
	$(RM) $(INSTALL_INCLUDE)/camd.h

=== CCOLAMD/Makefile ===
#------------------------------------------------------------------------------
# CCOLAMD Makefile
#------------------------------------------------------------------------------

VERSION = 2.8.0

default: all

include ../SuiteSparse_config/SuiteSparse_config.mk

demos: all

# Compile all C code
all:
	( cd Lib    ; $(MAKE) )
	( cd Demo   ; $(MAKE) )

# compile just the C-callable libraries (not Demos)
library:
	( cd Lib    ; $(MAKE) )

# remove object files, but keep the compiled programs and library archives
clean:
	( cd Lib    ; $(MAKE) clean )
	( cd Demo   ; $(MAKE) clean )
	( cd MATLAB ; $(RM) $(CLEAN) )

# clean, and then remove compiled programs and library archives
purge:
	( cd Lib    ; $(MAKE) purge )
	( cd Demo   ; $(MAKE) purge )
	( cd MATLAB ; $(RM) $(CLEAN) ; $(RM) *.mex* )

distclean: purge

# get ready for distribution
dist: purge
	( cd Demo   ; $(MAKE) dist )

ccode: library

lib: library

# install CCOLAMD
install:
	$(CP) Lib/libccolamd.a $(INSTALL_LIB)/libccolamd.$(VERSION).a
	( cd $(INSTALL_LIB) ; ln -sf libccolamd.$(VERSION).a libccolamd.a )
	$(CP) Include/ccolamd.h $(INSTALL_INCLUDE)
	chmod 644 $(INSTALL_LIB)/libccolamd*.a
	chmod 644 $(INSTALL_INCLUDE)/ccolamd.h

# uninstall CCOLAMD
uninstall:
	$(RM) $(INSTALL_LIB)/libccolamd*.a
	$(RM) $(INSTALL_INCLUDE)/ccolamd.h

=== CSparse/Makefile ===
#------------------------------------------------------------------------------
# CSparse Makefile
#------------------------------------------------------------------------------

VERSION = 3.1.2

C:
	( cd Lib ; $(MAKE) )
	( cd Demo ; $(MAKE) )

all: C cov

library:
	( cd Lib ; $(MAKE) )

cov:
	( cd Tcov ; $(MAKE) )

clean:
	( cd Lib ; $(MAKE) clean )
	( cd Demo ; $(MAKE) clean )
	( cd Tcov ; $(MAKE) clean )
	( cd MATLAB/CSparse ; $(RM) *.o )
	( cd MATLAB/Test    ; $(RM) *.o )

purge:
	( cd Lib ; $(MAKE) purge )
	( cd Demo ; $(MAKE) purge )
	( cd Tcov ; $(MAKE) purge )
	( cd MATLAB/CSparse ; $(RM) *.o *.mex* )
	( cd MATLAB/Test    ; $(RM) *.o *.mex* )

distclean: purge

# do not install CSparse; use CXSparse instead
install:

# uninstall CSparse: do nothing
uninstall:

=== LDL/Makefile ===
#------------------------------------------------------------------------------
# LDL Makefile
#------------------------------------------------------------------------------

VERSION = 2.1.0

default: all

include ../SuiteSparse_config/SuiteSparse_config.mk

demos: all

# Compile all C code, including the C-callable routine.
all:
	( cd Lib    ; $(MAKE) )
	( cd Demo   ; $(MAKE) )

# compile just the C-callable libraries (not Demos)
library:
	( cd Lib    ; $(MAKE) )

# remove object files, but keep the compiled programs and library archives
clean:
	( cd Lib    ; $(MAKE) clean )
	( cd Demo   ; $(MAKE) clean )
	( cd Doc    ; $(MAKE) clean )
	( cd MATLAB ; $(RM) $(CLEAN) )

# clean, and then remove compiled programs and library archives
purge:
	( cd Lib    ; $(MAKE) purge )
	( cd Demo   ; $(MAKE) purge )
	( cd Doc    ; $(MAKE) purge )
	( cd MATLAB ; $(RM) $(CLEAN) *.mex* )

distclean: purge

# create PDF documents for the original distribution
docs:
	( cd Doc    ; $(MAKE) )

# get ready for distribution
dist: purge
	( cd Demo   ; $(MAKE) dist )
	( cd Doc    ; $(MAKE) )

ccode: library

lib: library

# install LDL
install:
	$(CP) Lib/libldl.a $(INSTALL_LIB)/libldl.$(VERSION).a
	( cd $(INSTALL_LIB) ; ln -sf libldl.$(VERSION).a libldl.a )
	$(CP) Include/ldl.h $(INSTALL_INCLUDE)
	chmod 644 $(INSTALL_LIB)/libldl*.a
	chmod 644 $(INSTALL_INCLUDE)/ldl.h

# uninstall LDL
uninstall:
	$(RM) $(INSTALL_LIB)/libldl*.a
	$(RM) $(INSTALL_INCLUDE)/ldl.h

=== RBio/Makefile ===
#-------------------------------------------------------------------------------
# RBio Makefile
#-------------------------------------------------------------------------------

VERSION = 2.1.1

default: all

include ../SuiteSparse_config/SuiteSparse_config.mk

# Compile the C-callable libraries and the Demo programs.
all:
	( cd Lib ; $(MAKE) )
	( cd Demo ; $(MAKE) )

# Compile the C-callable libraries only.
library:
	( cd Lib ; $(MAKE) )

# Remove all files not in the original distribution
purge:
	( cd Tcov ; $(MAKE) purge )
	( cd Lib ; $(MAKE) purge )
	( cd Demo ; $(MAKE) purge )
	( cd RBio ; $(RM) $(CLEAN) private/temp.rb *.mex* )

# Remove all files not in the original distribution, except keep the 
# compiled libraries.
clean:
	( cd Tcov ; $(MAKE) clean )
	( cd Lib ; $(MAKE) clean )
	( cd Demo ; $(MAKE) clean )
	( cd RBio ; $(RM) $(CLEAN) private/temp.rb )

distclean: purge

ccode: all

# Run the test coverage suite.
cov:
	( cd Tcov ; $(MAKE) go )

# Run the test coverage suite using Valgrind.
valgrind:
	( cd Valgrind ; $(MAKE) )

# Compile the C-callable libraries and the Demo programs.
demos:
	( cd Demo ; $(MAKE) )


# install RBio
install:
	$(CP) Lib/librbio.a $(INSTALL_LIB)/librbio.$(VERSION).a
	( cd $(INSTALL_LIB) ; ln -sf librbio.$(VERSION).a librbio.a )
	$(CP) Include/RBio.h $(INSTALL_INCLUDE)
	chmod 644 $(INSTALL_LIB)/librbio*.a
	chmod 644 $(INSTALL_INCLUDE)/RBio.h

# uninstall RBio
uninstall:
	$(RM) $(INSTALL_LIB)/librbio*.a
	$(RM) $(INSTALL_INCLUDE)/RBio.h

=== UMFPACK/Makefile ===
#-------------------------------------------------------------------------------
# UMFPACK Makefile
#-------------------------------------------------------------------------------

VERSION = 5.6.2

# UMFPACK requires the AMD package to be in ../AMD

default: all

include ../SuiteSparse_config/SuiteSparse_config.mk

# compile all C code (except hb, fortran, and fortran64), incl. AMD and demos
all:
	( cd Demo   ; $(MAKE) )

# compile just the C-callable UMFPACK library
library:
	( cd Lib    ; $(MAKE) )

# compile the FORTRAN interface and demo program
fortran:
	( cd Demo   ; $(MAKE) fortran )

# compile the 64-bit FORTRAN interface and demo program
fortran64:
	( cd Demo   ; $(MAKE) fortran64 )

# compile the Harwell/Boeing demo program
hb:
	( cd Demo   ; $(MAKE) hb )

# remove object files, but keep the compiled programs and library archives
clean:
	( cd Lib    ; $(MAKE) clean )
	( cd Demo   ; $(MAKE) clean )
	( cd Doc    ; $(MAKE) clean )
	( cd MATLAB ; $(RM) $(CLEAN) rename.h )

# clean, and then remove compiled programs and library archives
purge:
	( cd Lib    ; $(MAKE) purge )
	( cd Demo   ; $(MAKE) purge )
	( cd Doc    ; $(MAKE) purge )
	( cd Tcov   ; $(MAKE) purge )
	( cd MATLAB ; $(RM) $(CLEAN) rename.h *.mex* )

# create PDF documents for the original distribution
docs:
	( cd Doc    ; $(MAKE) )

# get ready for distribution
dist: purge
	( cd Demo   ; $(MAKE) dist )
	( cd Doc    ; $(MAKE) )

distclean: purge

ccode: library

# statement coverage (requires Linux; takes a lot of time and disk space)
cov: purge
	( cd Tcov ; ./DO.linux )

# install UMFPACK
install:
	$(CP) Lib/libumfpack.a $(INSTALL_LIB)/libumfpack.$(VERSION).a
	( cd $(INSTALL_LIB) ; ln -sf libumfpack.$(VERSION).a libumfpack.a )
	$(CP) Include/*.h $(INSTALL_INCLUDE)
	chmod 644 $(INSTALL_LIB)/libumfpack*.a
	chmod 644 $(INSTALL_INCLUDE)/umfpack*.h

# uninstall UMFPACK
uninstall:
	$(RM) $(INSTALL_LIB)/libumfpack*.a
	$(RM) $(INSTALL_INCLUDE)/umfpack*.h

=== CAMD/Demo/Makefile ===
#-----------------------------------------------------------------------------
# compile the CAMD demo (for both GNU make or original make)
#-----------------------------------------------------------------------------

default: camd_simple camd_demo camd_demo2 camd_l_demo

include ../../SuiteSparse_config/SuiteSparse_config.mk

C = $(CC) $(CF) -I../Include -I../../SuiteSparse_config

INC = ../Include/camd.h ../../SuiteSparse_config/SuiteSparse_config.h

library:
	( cd ../Lib ; $(MAKE) )

#------------------------------------------------------------------------------
# Create the demo program, run it, and compare the output
#------------------------------------------------------------------------------

dist:

camd_demo: camd_demo.c library $(INC)
	$(C) -o camd_demo camd_demo.c ../Lib/libcamd.a $(LIB)
	./camd_demo > my_camd_demo.out
	- diff camd_demo.out my_camd_demo.out

camd_l_demo: camd_l_demo.c library $(INC)
	$(C) -o camd_l_demo camd_l_demo.c ../Lib/libcamd.a $(LIB)
	./camd_l_demo > my_camd_l_demo.out
	- diff camd_l_demo.out my_camd_l_demo.out

camd_demo2: camd_demo2.c library $(INC)
	$(C) -o camd_demo2 camd_demo2.c ../Lib/libcamd.a $(LIB)
	./camd_demo2 > my_camd_demo2.out
	- diff camd_demo2.out my_camd_demo2.out

camd_simple: camd_simple.c library $(INC)
	$(C) -o camd_simple camd_simple.c ../Lib/libcamd.a $(LIB)
	./camd_simple > my_camd_simple.out
	- diff camd_simple.out my_camd_simple.out

#------------------------------------------------------------------------------
# Remove all but the files in the original distribution
#------------------------------------------------------------------------------

clean:
	- $(RM) $(CLEAN)

purge: distclean

distclean: clean
	- $(RM) camd_demo my_camd_demo.out
	- $(RM) camd_l_demo my_camd_l_demo.out
	- $(RM) camd_demo2 my_camd_demo2.out
	- $(RM) camd_simple my_camd_simple.out
	- $(RM) -r *.dSYM

=== CAMD/Lib/Makefile ===
#-------------------------------------------------------------------------------
# CAMD Makefile for compiling on Unix systems (for original Make ONLY)
#-------------------------------------------------------------------------------

# This is a very ugly Makefile, and is only provided for those who do not
# have GNU make.  Note that it is not used if you have GNU make.  It ignores
# dependency checking and just compiles everything.

default: everything

include ../../SuiteSparse_config/SuiteSparse_config.mk

C = $(CC) $(CF) -I../Include -I../../SuiteSparse_config

everything:
	$(C) -DDINT -c ../Source/camd_aat.c -o camd_i_aat.o
	$(C) -DDINT -c ../Source/camd_1.c -o camd_i_1.o
	$(C) -DDINT -c ../Source/camd_2.c -o camd_i_2.o
	$(C) -DDINT -c ../Source/camd_dump.c -o camd_i_dump.o
	$(C) -DDINT -c ../Source/camd_postorder.c -o camd_i_postorder.o
	$(C) -DDINT -c ../Source/camd_defaults.c -o camd_i_defaults.o
	$(C) -DDINT -c ../Source/camd_order.c -o camd_i_order.o
	$(C) -DDINT -c ../Source/camd_control.c -o camd_i_control.o
	$(C) -DDINT -c ../Source/camd_info.c -o camd_i_info.o
	$(C) -DDINT -c ../Source/camd_valid.c -o camd_i_valid.o
	$(C) -DDINT -c ../Source/camd_preprocess.c -o camd_i_preprocess.o
	$(C) -DDLONG -c ../Source/camd_aat.c -o camd_l_aat.o
	$(C) -DDLONG -c ../Source/camd_1.c -o camd_l_1.o
	$(C) -DDLONG -c ../Source/camd_2.c -o camd_l_2.o
	$(C) -DDLONG -c ../Source/camd_dump.c -o camd_l_dump.o
	$(C) -DDLONG -c ../Source/camd_postorder.c -o camd_l_postorder.o
	$(C) -DDLONG -c ../Source/camd_defaults.c -o camd_l_defaults.o
	$(C) -DDLONG -c ../Source/camd_order.c -o camd_l_order.o
	$(C) -DDLONG -c ../Source/camd_control.c -o camd_l_control.o
	$(C) -DDLONG -c ../Source/camd_info.c -o camd_l_info.o
	$(C) -DDLONG -c ../Source/camd_valid.c -o camd_l_valid.o
	$(C) -DDLONG -c ../Source/camd_preprocess.c -o camd_l_preprocess.o
	$(C) -c ../Source/camd_global.c
	$(ARCHIVE)  libcamd.a \
            camd_i_aat.o camd_i_1.o camd_i_2.o camd_i_dump.o \
	    camd_i_postorder.o camd_i_defaults.o camd_i_order.o \
	    camd_i_control.o camd_i_info.o camd_i_valid.o camd_l_aat.o \
	    camd_l_1.o camd_l_2.o camd_l_dump.o camd_l_postorder.o \
	    camd_l_defaults.o camd_l_order.o camd_l_control.o camd_l_info.o \
	    camd_l_valid.o camd_i_preprocess.o camd_l_preprocess.o camd_global.o
	- $(RANLIB) libcamd.a

#-------------------------------------------------------------------------------
# Remove all but the files in the original distribution
#-------------------------------------------------------------------------------

clean:
	- $(RM) $(CLEAN)

purge: distclean

distclean: clean
	- $(RM) libcamd.a

=== CCOLAMD/Demo/Makefile ===
#-----------------------------------------------------------------------------
# compile the CCOLAMD demo
#-----------------------------------------------------------------------------

default: ccolamd_example ccolamd_l_example

include ../../SuiteSparse_config/SuiteSparse_config.mk

I = -I../Include -I../../SuiteSparse_config

C = $(CC) $(CF) $(I)

library:
	( cd ../Lib ; $(MAKE) )

#------------------------------------------------------------------------------
# Create the demo program, run it, and compare the output
#------------------------------------------------------------------------------

dist:

ccolamd_example: ccolamd_example.c library
	$(C) -o ccolamd_example ccolamd_example.c ../Lib/libccolamd.a -lm
	- ./ccolamd_example > my_ccolamd_example.out
	- diff ccolamd_example.out my_ccolamd_example.out

ccolamd_l_example: ccolamd_l_example.c library
	$(C) -o ccolamd_l_example ccolamd_l_example.c ../Lib/libccolamd.a -lm
	- ./ccolamd_l_example > my_ccolamd_l_example.out
	- diff ccolamd_l_example.out my_ccolamd_l_example.out

#------------------------------------------------------------------------------
# Remove all but the files in the original distribution
#------------------------------------------------------------------------------

clean:
	- $(RM) $(CLEAN)

purge: distclean

distclean: clean
	- $(RM) ccolamd_example ccolamd_l_example
	- $(RM) my_ccolamd_example.out my_ccolamd_l_example.out
	- $(RM) -r *.dSYM

=== CHOLMOD/Demo/Makefile ===
#===============================================================================
# CHOLMOD/Demo/Makefile
#===============================================================================

# If you compile CHOLMOD with -DNPARTITION, then you do not need METIS or
# CCOLAMD. 

default: all

include ../../SuiteSparse_config/SuiteSparse_config.mk

#-------------------------------------------------------------------------------
# the optional Partition module requires METIS, CAMD, and CCOLAMD.
# CAMD and CCOLAMD can be installed without METIS, but are optional.
I_WITH_PARTITION = 
LIB_WITH_PARTITION =
CONFIG = -DNPARTITION -DNCAMD
# check if CAMD/CCOLAMD and METIS are requested and available
ifeq (,$(findstring -DNCAMD, $(CHOLMOD_CONFIG)))
    # CAMD and CCOLAMD are requested.  See if they are available
    ifeq (../../CAMD, $(wildcard ../../CAMD))
        ifeq (../../CCOLAMD, $(wildcard ../../CCOLAMD))
            # CAMD and CCOLAMD are requested and available
            LIB_WITH_PARTITION = \
                        ../../CCOLAMD/Lib/libccolamd.a ../../CAMD/Lib/libcamd.a
            I_WITH_PARTITION = \
                        -I../../CCOLAMD/Include -I../../CAMD/Include
            CONFIG = -DNPARTITION
            # check if METIS is requested and available
            ifeq (,$(findstring -DNPARTITION, $(CHOLMOD_CONFIG)))
                # METIS is requested.  See if it is available
                ifeq ($(METIS_PATH), $(wildcard $(METIS_PATH)))
                    # METIS is available
                    LIB_WITH_PARTITION = $(METIS) \
                        ../../CCOLAMD/Lib/libccolamd.a ../../CAMD/Lib/libcamd.a
                    I_WITH_PARTITION = -I$(METIS_PATH)/Lib \
                        -I../../CCOLAMD/Include -I../../CAMD/Include
                    CONFIG =
                endif
            endif
        endif
    endif
endif

#-------------------------------------------------------------------------------

LIB2 = ../Lib/libcholmod.a ../../AMD/Lib/libamd.a ../../COLAMD/Lib/libcolamd.a \
        ../../SuiteSparse_config/libsuitesparseconfig.a \
	$(LIB_WITH_PARTITION) $(LAPACK) $(BLAS) $(XERBLA) $(LIB)

#-------------------------------------------------------------------------------
# With the CUDA BLAS:
ifneq ($(GPU_CONFIG),)
LIB2 += $(GPU_BLAS_PATH)/lib64/libcudart.so $(GPU_BLAS_PATH)/lib64/libcublas.so
endif
#-------------------------------------------------------------------------------

C = $(CC) $(CF) $(CHOLMOD_CONFIG) $(CONFIG)

code: library cholmod_demo cholmod_l_demo cholmod_simple

fortran: readhb readhb2 reade 

all: code
	./cholmod_demo < Matrix/bcsstk01.tri
	./cholmod_l_demo < Matrix/bcsstk01.tri
	./cholmod_demo < Matrix/lp_afiro.tri
	./cholmod_l_demo < Matrix/lp_afiro.tri
	./cholmod_demo < Matrix/can___24.mtx
	./cholmod_l_demo < Matrix/can___24.mtx
	./cholmod_demo < Matrix/c.tri
	./cholmod_l_demo < Matrix/c.tri
	./cholmod_simple < Matrix/c.tri
	./cholmod_simple < Matrix/can___24.mtx
	./cholmod_simple < Matrix/bcsstk01.tri

distclean: purge

purge: clean
	- $(RM) cholmod_demo cholmod_l_demo readhb readhb2 reade
	- $(RM) cholmod_simple
	- $(RM) timelog.m
	- $(RM) -r *.dSYM

clean:
	- $(RM) $(CLEAN)

#-------------------------------------------------------------------------------
# See below if you compile with -DNPARTITION
library:
	( cd ../../SuiteSparse_config/xerbla ; $(MAKE) )
	( cd ../../SuiteSparse_config ; $(MAKE) )
	( cd ../Lib ; $(MAKE) )
	( cd ../../AMD ; $(MAKE) library )
	( cd ../../COLAMD ; $(MAKE) library )
ifneq (,$(findstring -DCAMD, $(CONFIG)))
else
	( cd ../../CCOLAMD ; $(MAKE) library )
	( cd ../../CAMD ; $(MAKE) library )
endif
ifneq (,$(findstring -DNPARTITION, $(CONFIG)))
else
	( cd $(METIS_PATH) && $(MAKE) )
endif

#-------------------------------------------------------------------------------

I = -I../Include -I../../SuiteSparse_config

cholmod_demo: library cholmod_demo.c cholmod_demo.h
	$(C) -o cholmod_demo $(I) cholmod_demo.c $(LIB2)

cholmod_simple: library cholmod_simple.c
	$(C) -o cholmod_simple $(I) cholmod_simple.c $(LIB2)

cholmod_l_demo: library cholmod_l_demo.c cholmod_demo.h
	$(C) -o cholmod_l_demo $(I) cholmod_l_demo.c $(LIB2)

readhb: readhb.f
	$(F77) $(FFLAGS) -o readhb readhb.f

readhb2: readhb2.f
	$(F77) $(FFLAGS) -O -o readhb2 readhb2.f

reade: reade.f
	$(F77) $(FFLAGS) -O -o reade reade.f

=== debian/changelog ===
suitesparse (1:4.2.1-3ubuntu1) trusty; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - debian/control: Demote libatlas-doc from Recommends to Suggests, as it
      is not in main.

 -- Logan Rosen <logan@ubuntu.com>  Sat, 07 Dec 2013 21:42:26 -0500

suitesparse (1:4.2.1-3) unstable; urgency=low

  * Upload to unstable.
  * Register user guides for KLU, CAMD, SPQR and LDL in doc-base.

 -- Sébastien Villemot <sebastien@debian.org>  Sun, 01 Dec 2013 22:09:21 +0100

suitesparse (1:4.2.1-2) experimental; urgency=low

  * Really fix BLAS/LAPACK dependencies of libsuitesparse-dev
    - remove obsolete ATLAS specialized libraries (Closes: #645846)
    - add virtual package libblas.so as a BLAS alternative (Closes: #645844)
  * Remove Daniel Rus Morales from Uploaders, with his consent. Thanks
    Daniel for your work!
  * d/rules: do not regenerate d/control automatically, this is
    forbidden
  * d/rules: fix get-orig-source rule
  * d/control: use canonical URLs for Vcs-* fields
  * Mark debug package as Multi-Arch: same
  * Ship libsuitesparseconfig.a in the -dev package.
  * Bump Standards-Version to 3.9.5, no changes needed.

 -- Sébastien Villemot <sebastien@debian.org>  Wed, 13 Nov 2013 18:26:35 +0100

suitesparse (1:4.2.1-1) experimental; urgency=low

  * New upstream release (Closes: #706709)
    - debian/library-soname.pl: update soversion numbers
  * debian/rules: recreate d/control when d/library-sonames.pl is
    modified

 -- Sébastien Villemot <sebastien@debian.org>  Fri, 03 May 2013 18:36:14 +0200

suitesparse (1:4.2.0-1) experimental; urgency=low

  [ Christophe Trophime ]
  * New upstream release (Closes: #653660, #687282)
    - Renamed UFconfig to SuiteSparse_config
    - Update patches to new release
    - debian/library-soname.pl: update soversion numbers
      
  [ Sébastien Villemot ]
  * debian/control.in:
    - fix Maintainer field (Closes: #674266, #674268, #674270, #674271, #674272,
      #674273, #674274, #674275, #674276, #674277, #674278, #674279, #674280,
      #674281)
    - add myself to Uploaders
    - remove obsolete DM-Upload-Allowed flag
  * Remove obsolete README.source
  * debian/rules: clean *.oo files
  * Bump to debhelper compat level 9
  * Update debian/copyright
  * Remove symbols files: they are useless since we bump the soversion
    at every new upstream release
  * Clean up build flags
    - make sure to inject flags from dpkg-buildflags
    - buildflags.diff: new patch to remove spurious flags in upstream build
      system
    - remove -m64 flag on amd64 CPUs (Closes: #701654)
  * Fix version in NEWS.Debian, to make lintian happy
  * parallel-build.diff: new patch, fixes parallel build
  * Multiarchify the package
  * Fix BLAS/LAPACK dependencies of libsuitesparse-dev:
    - remove obsolete ATLAS specialized libraries (Closes: #645846)
    - add libopenblas-dev as a BLAS alternative (Closes: #645844)
  * Bump to Standards-Version 3.9.4, no changes needed
  * Suitesparse_config_Makefile.diff: new patch, creates a PIC version
    of the (small) config code, for embedding in other shared libs
  * KLU_Demo_Makefile.diff: new patch, needed for creating the right
    dependencies between shared libraries
  * Create a new shared library package for SPQR (Closes: #589296)
  * Update README.Debian

 -- Sébastien Villemot <sebastien@debian.org>  Mon, 29 Apr 2013 16:14:58 +0200

suitesparse (1:3.4.0-3ubuntu1) raring; urgency=low

  * Resynchronize on Debian, remaining change
  * Demote libatlas-doc from Recommends to Suggests, as it is not in main.

 -- Sebastien Bacher <seb128@ubuntu.com>  Tue, 06 Nov 2012 13:14:34 +0100

suitesparse (1:3.4.0-3) unstable; urgency=low

  * Team upload.

  [ Sylvestre Ledru ]
  * Standard-Version updated to 3.9.3 (no changes requiered)

  [ Evgeni Golov ]
  * [f782819] Add -g to CFLAGS. (Closes: #682177)
  * [d43b31b] Honour CFLAGS in debian/patches/09-CSparse_Lib_Makefile.diff

  [ Anton Gladky ]
  * [3a0e1c1] Move repository into debian-science.

 -- Evgeni Golov <evgeni@debian.org>  Sat, 04 Aug 2012 22:40:53 +0200

suitesparse (1:3.4.0-2) unstable; urgency=low

  * Maintainer changed to Debian Science
  * Updated list of Uploaders (Closes: #571884, #550417)
  * Standards-Version updated to version 3.8.4
  * Link against -llapackgf-3 changed to -llapack (Closes: #577879)
  * Removed doc-central recommends (Closes: #566361)

 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 15 Apr 2010 10:36:16 +0200

suitesparse (1:3.4.0-1) unstable; urgency=low

  [ Rafael Laboissiere ]
  * New upstream release
  * debian/patches/14-SPQR_Include_spqr_hpp.dpatch: Removed patch (applied
    upstream)

  * Split the libraries into individual packages
    + The new binary packages are (the soversion numbers are the ones
      provided by the upstream authors in the UFconfig/UFconfig.h file):
      - libamd2.2.0
      - libbtf1.1.0
      - libcamd2.2.0
      - libcolamd2.7.1
      - libccolamd2.7.1
      - libcholmod1.7.1
      - libcsparse2.2.3
      - libcxsparse2.2.3
      - libklu1.1.0
      - libldl2.0.1
      - libumfpack5.4.0
    + The libsuitesparse-dev and libsuitesparse-dbg packages remain as
      before.  They depend on all the binary packages above.
    + debian/library-soname.pl: New Perl script that is used everywhere to
      obtain the name of the package for each library.  This is the
      centralized place where this information should be provided.
    + The debian/control file has been moved into debian/control.in and is
      automatically generated by debian/rules with the appropriate names
      of the packages being replaced.
    + debian/patches/*.diff: All the patches have been adapted for
      obtaining the library soversion using the debian/library-soname.pl
      script.
    + debian/symbols/*, debian/install/*: These are the source files for
      the debian/lib*.symbols and debian/lib*.install.  The later are
      obtained from the former in debian/rules by using the appropriate


=== debian/control ===
Source: suitesparse
Section: math
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Christophe Prud'homme <prudhomm@debian.org>,
 Sébastien Villemot <sebastien@debian.org>
Build-Depends: cdbs (>= 0.4.52), debhelper (>= 9), dh-exec, gfortran,
 libblas-dev, liblapack-dev
Standards-Version: 3.9.5
Homepage: http://www.cise.ufl.edu/research/sparse/SuiteSparse/
Vcs-Git: git://anonscm.debian.org/debian-science/packages/suitesparse.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-science/packages/suitesparse.git

Package: libamd2.3.1
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: approximate minimum degree ordering library for sparse matrices
 Suitesparse is a collection of libraries for computations involving
 sparse matrices.  This package includes the following dynamic library:
 .
 AMD         approximate minimum degree ordering

Package: libbtf1.2.0
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: permutation to block triangular form library for sparse matrices
 Suitesparse is a collection of libraries for computations involving
 sparse matrices.  This package includes the following dynamic library:
 .
 BTF         permutation to block triangular form (beta)

Package: libcamd2.3.1
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: symmetric approximate minimum degree library for sparse matrices
 Suitesparse is a collection of libraries for computations involving
 sparse matrices.  This package includes the following dynamic library:
 .
 CAMD        symmetric approximate minimum degree

Package: libcolamd2.8.0
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: column approximate minimum degree ordering library for sparse matrices
 Suitesparse is a collection of libraries for computations involving
 sparse matrices.  This package includes the following dynamic library:
 .
 COLAMD      column approximate minimum degree ordering

Package: libccolamd2.8.0
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: constrained column approximate library for sparse matrices
 Suitesparse is a collection of libraries for computations involving
 sparse matrices.  This package includes the following dynamic library:
 .
 COLAMD      constrained column approximate minimum degree ordering

Package: libcholmod2.1.2
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: sparse Cholesky factorization library for sparse matrices
 Suitesparse is a collection of libraries for computations involving
 sparse matrices.  This package includes the following dynamic library:
 .
 CHOLMOD     sparse Cholesky factorization

Package: libcsparse3.1.2
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: concise sparse matrix library
 Suitesparse is a collection of libraries for computations involving
 sparse matrices.  This package includes the following dynamic library:
 .
 CSparse     a concise sparse matrix package

Package: libcxsparse3.1.2
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: concise sparse matrix library (complex, int and long int support)
 Suitesparse is a collection of libraries for computations involving
 sparse matrices.  This package includes the following dynamic library:
 .
 CXSparse    CSparse extended: complex matrix, int and long int support

Package: libklu1.2.1
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: circuit simulation sparse LU factorization library
 Suitesparse is a collection of libraries for computations involving
 sparse matrices.  This package includes the following dynamic library:
 .
 KLU         sparse LU factorization, primarily for circuit simulation

Package: libldl2.1.0
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: simple LDL' factorization library for sparse matrices
 Suitesparse is a collection of libraries for computations involving
 sparse matrices.  This package includes the following dynamic library:
 .
 LDL         a simple LDL' factorization

Package: libumfpack5.6.2
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: sparse LU factorization library
 Suitesparse is a collection of libraries for computations involving
 sparse matrices.  This package includes the following dynamic library:
 .
 UMFPACK     sparse LU factorization

Package: libspqr1.3.1
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: sparse QR factorization library
 Suitesparse is a collection of libraries for computations involving
 sparse matrices.  This package includes the following dynamic library:
 .
 SPQR        sparse QR factorization library

Package: libsuitesparse-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Replaces: libufsparse-dev, libsuitesparse-metis-dev, libumfpack4-dev
Conflicts: libufsparse-dev, libsuitesparse-metis-dev, libumfpack4-dev
Provides: libufsparse-dev, libumfpack4-dev
Depends: ${misc:Depends},
 libamd2.3.1 (= ${binary:Version}),
 libcamd2.3.1 (= ${binary:Version}),
 libbtf1.2.0 (= ${binary:Version}),
 libcolamd2.8.0 (= ${binary:Version}),
 libccolamd2.8.0 (= ${binary:Version}),
 libcholmod2.1.2 (= ${binary:Version}),
 libcsparse3.1.2 (= ${binary:Version}),
 libcxsparse3.1.2 (= ${binary:Version}),
 libklu1.2.1 (= ${binary:Version}),
 libldl2.1.0 (= ${binary:Version}),
 libumfpack5.6.2 (= ${binary:Version}),
 libspqr1.3.1 (= ${binary:Version}),
 libblas-dev | libblas.so,
 liblapack-dev | liblapack.so
Description: libraries for sparse matrices computations (development files)
 Suitesparse is a collection of libraries for computations involving
 sparse matrices.  This package includes the following libraries:
 .
 AMD         approximate minimum degree ordering
 .
 CAMD        symmetric approximate minimum degree
 .
 BTF         permutation to block triangular form (beta)
 .
 COLAMD      column approximate minimum degree ordering
 .
 CCOLAMD     constrained column approximate minimum degree ordering
 .
 CHOLMOD     sparse Cholesky factorization
 .
 CSparse     a concise sparse matrix package
 .
 CXSparse    CSparse extended: complex matrix, int and long int support
 .
 KLU         sparse LU factorization, primarily for circuit simulation
 .
 LDL         a simple LDL' factorization
 .
 UMFPACK     sparse LU factorization
 .
 SPQR        sparse QR factorization
 .
 This package contains the static libraries and header files.

Package: libsuitesparse-dbg
Section: debug
Priority: extra
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
 libamd2.3.1 (= ${binary:Version}),
 libcamd2.3.1 (= ${binary:Version}),
 libbtf1.2.0 (= ${binary:Version}),
 libcolamd2.8.0 (= ${binary:Version}),
 libccolamd2.8.0 (= ${binary:Version}),
 libcholmod2.1.2 (= ${binary:Version}),
 libcsparse3.1.2 (= ${binary:Version}),
 libcxsparse3.1.2 (= ${binary:Version}),
 libklu1.2.1 (= ${binary:Version}),
 libldl2.1.0 (= ${binary:Version}),
 libumfpack5.6.2 (= ${binary:Version}),
 libspqr1.3.1 (= ${binary:Version}),
 libblas-dev | libblas.so,
 liblapack-dev | liblapack.so
Conflicts: libufsparse-dbg
Replaces: libufsparse-dbg
Description: libraries for sparse matrices computations (debugging symbols)
 Suitesparse is a collection of libraries for computations involving
 sparse matrices.  This package includes the following libraries:
 .
 AMD         approximate minimum degree ordering
 .
 CAMD        symmetric approximate minimum degree
 .
 BTF         permutation to block triangular form (beta)
 .
 COLAMD      column approximate minimum degree ordering
 .
 CCOLAMD     constrained column approximate minimum degree ordering
 .
 CHOLMOD     sparse Cholesky factorization
 .
 CSparse     a concise sparse matrix package
 .
 CXSparse    CSparse extended: complex matrix, int and long int support
 .
 KLU         sparse LU factorization, primarily for circuit simulation
 .
 LDL         a simple LDL' factorization
 .
 UMFPACK     sparse LU factorization
 .
 SPQR        sparse QR factorization
 .
 SuiteSparse_config    configuration file for all the above packages.
 .
 This package contains the debug libraries (stored in /usr/lib/debug).

Package: libsuitesparse-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Replaces: libufsparse-doc, libumfpack4-doc
Conflicts: libufsparse-doc, libumfpack4-doc
Recommends: libblas-doc
Suggests: libatlas-doc
Description: libraries for sparse matrices computations (documentation)
 Suitesparse is a collection of libraries for computations involving
 sparse matrices.  This package contains the user guides for the
 libraries distributed by the SuiteSparse project.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/cdbs/1/class/makefile.mk
include /usr/share/cdbs/1/rules/debhelper.mk

DEB_AUTO_CLEANUP_RCS	:= yes
DEB_SRCDIR 		:= $(CURDIR)/
DEB_BUILDDIR 		:= $(DEB_SRCDIR)/

DEB_MAKE_CLEAN_TARGET    := clean
DEB_MAKE_BUILD_TARGET    := default
DEB_COMPRESS_EXCLUDE_ALL := .pdf

# List of libraries provided by SuiteSparse
LIBRARIES = AMD CAMD BTF COLAMD CCOLAMD CHOLMOD CSparse CXSparse KLU LDL UMFPACK SPQR
# Generate variables like "AMD = libamd<soversion>"
$(foreach lib, $(LIBRARIES), $(eval $(lib) = $(shell perl debian/library-soname.pl $(lib))))
# Lists of lib*.install files
INSTALL_FILES = $(foreach lib, $(LIBRARIES), debian/$($(lib)).install)

# Rule for regenerating debian/control from debian/control.in
# Note that this should not be automatized, see http://ftp-master.debian.org/REJECT-FAQ.html
generate-debian-control: debian/control.in debian/library-soname.pl
	sed "$(foreach lib, $(LIBRARIES), s/@$(lib)@/$($(lib))/g;)" < debian/control.in > debian/control
.PHONY: generate-debian-control

# Generate rules for debian/lib*.install
$(foreach lib, $(LIBRARIES), $(eval debian/$($(lib)).%: debian/%/$(lib) ; cp $$< $$@))

makebuilddir:: $(INSTALL_FILES) debian/control

common-build-arch::
	-( cd AMD/Doc      && mv ChangeLog AMD_ChangeLog )
	-( cd CAMD/Doc     && mv ChangeLog CAMD_ChangeLog )
	-( cd CCOLAMD/Doc  && mv ChangeLog CCOLAMD_ChangeLog )
	-( cd COLAMD/Doc   && mv ChangeLog COLAMD_ChangeLog )
	-( cd BTF/Doc      && mv ChangeLog BTF_ChangeLog )
	-( cd KLU/Doc      && mv ChangeLog KLU_ChangeLog )
	-( cd LDL/Doc      && mv ChangeLog LDL_ChangeLog )
	-( cd UMFPACK/Doc  && mv ChangeLog UMFPACK_ChangeLog )
	-( cd CHOLMOD/Doc  && mv ChangeLog CHOLMOD_ChangeLog )
	-( cd CSparse/Doc  && mv ChangeLog CSparse_ChangeLog )
	-( cd CXSparse/Doc && mv ChangeLog CXSparse_ChangeLog )
	-( cd SPQR/Doc     && mv ChangeLog SPQR_ChangeLog )

build/libsuitesparse-doc::
	-( cd CHOLMOD/Doc && mv UserGuide.pdf CHOLMOD_UserGuide.pdf && mv UserGuide.bib CHOLMOD_UserGuide.bib )
	-( cd UMFPACK/Doc && mv UserGuide.pdf UMFPACK_UserGuide.pdf && mv UserGuide.bib UMFPACK_UserGuide.bib )
	-( cd UMFPACK/Doc && mv QuickStart.pdf UMFPACK_QuickStart.pdf )

cleanbuilddir::
	-( cd AMD/Doc      && mv AMD_ChangeLog ChangeLog )
	-( cd CAMD/Doc     && mv CAMD_ChangeLog ChangeLog )
	-( cd CCOLAMD/Doc  && mv CCOLAMD_ChangeLog ChangeLog )
	-( cd COLAMD/Doc   && mv COLAMD_ChangeLog ChangeLog )
	-( cd BTF/Doc      && mv BTF_ChangeLog ChangeLog )
	-( cd KLU/Doc      && mv KLU_ChangeLog ChangeLog )
	-( cd LDL/Doc      && mv LDL_ChangeLog ChangeLog )
	-( cd UMFPACK/Doc  && mv UMFPACK_ChangeLog ChangeLog )
	-( cd CHOLMOD/Doc  && mv CHOLMOD_ChangeLog ChangeLog )
	-( cd CSparse/Doc  && mv CSparse_ChangeLog ChangeLog )
	-( cd CXSparse/Doc && mv CXSparse_ChangeLog ChangeLog )
	-( cd SPQR/Doc     && mv SPQR_ChangeLog ChangeLog )

cleanbuilddir/libsuitesparse-doc::
	-( cd CHOLMOD/Doc && mv CHOLMOD_UserGuide.pdf UserGuide.pdf && mv CHOLMOD_UserGuide.bib UserGuide.bib )
	-( cd UMFPACK/Doc && mv UMFPACK_UserGuide.pdf UserGuide.pdf && mv UMFPACK_UserGuide.bib UserGuide.bib )
	-( cd UMFPACK/Doc && mv UMFPACK_QuickStart.pdf QuickStart.pdf )

clean::
	-make purge
	-find $(DEB_BUILDDIR) -name "*.a" | xargs rm
	-find $(DEB_BUILDDIR) -name "*.so*" | xargs rm
	-find $(DEB_BUILDDIR) -name "*.oo" | xargs rm
	rm -f $(INSTALL_FILES)

get-orig-source:
	uscan --force-download --rename --destdir .
.PHONY: get-orig-source

=== debian/watch ===
version=3
http://www.cise.ufl.edu/research/sparse/SuiteSparse/SuiteSparse-([\d.]+)\.tar\.gz
